import pandas as pd
from openpyxl import load_workbook
import decimal
import os
import time

# 변수세팅
nameline=[
    'N_FNAME', 'N_FNAME3', 'Sort', 'Beta-Carotene (microgram)',
    'Alpha-Carotene (mg)', 'Beta-Cryptoxanthin (mg)', 'Lycopene (mg)',
    'Lutein (mg)', 'Zeaxanthin (mg)', 'Retinol (microgram)',
    'Ascorbic acid (mg)', 'Alpha-Tocopherol (mg)', 'Gamma-Tocopherol (mg)',
    'Quercetin (mg)', 'Kampferol (mg)', 'Myricetin (mg)', 'Isorhamnetin (mg)',
    'Luteolin (mg)', 'Apigenin (mg)', 'Hesperetin (mg)', 'Naringenin (mg)',
    'Eriodictyol (mg)', '(+)-Catechin (mg)', '(+)-Gallocatechin (mg)',
    '(-)-Epicatechin (mg)', '(-)-Epigallocatechin (mg)',
    '(-)-Epicatechin 3-gallate (mg)', '(-)-Epigallocatechin 3-gallate (mg)',
    'Theaflavin (mg)', 'Theaflavin 3-gallate (mg)',"Theaflavin 3'-gallate (mg)",
    "Theaflavin 3,3'-digallate (mg)",'Cyanidin (mg)', 'Delphinidin (mg)',
    'Malvidin (mg)', 'Pelargonidin (mg)', 'Peonidin (mg)', 'Petunidin (mg)',
    'Daidzain (mg)', 'Genistein (mg)', 'Glycitein (mg)', 'Biochanin A (mg)',
    'Formononetin (mg)', 'Procyanidin (mg)', 'Cinnamtannin B1 (mg)'
    ]
nutrientAntioxidantCapacity=[
    '0.00000252', '0.00073', '0.00167', '0.00587', '0.00234', '0.00257',
    '0.000481', '1', '0.00267', '0.00403', '0.02294', '0.01146', '0.02618',
    '0.01213', '0.01783', '0.00898', '0.01011', '0.01351', '0.01235',
    '0.02157', '0.01838', '0.02455', '0.02644', '0.02214', '0.02349',
    '0.01415', '0.01541', '0.01541', '0.01467', '0.0240', '0.02602',
    '0.01558', '0.01577', '0.01335', '0.02445', '0.00718', '0.0128',
    '0.00752', '0.00256', '0', '0.01681', '0.01466'
    ]

tac={}
people=[]
subsum=[]
sc=0
dtac=[]
dtacd=[]
# vLo = Variable Locaion
vLo={}
supplement=0
missingData=0
templine=[]
now = time.localtime()
currentTime = "%04d%02d%02d%02d%02d%02d" % (now.tm_year, now.tm_mon,
                                            now.tm_mday, now.tm_hour,
                                            now.tm_min, now.tm_sec)

# 엔딩크레딧
def ending(countdown):
    print('Closing countdown')
    for i in range(0,countdown+1):
        print(countdown-i)
        time.sleep(1)
    quit()

# 파일 서칭
os.chdir('.')
targetFilePath=os.getcwd()
if os.path.isfile('dtacdb.xlsx'):
    tacWorkbook = load_workbook(filename="dtacdb.xlsx", data_only=True)
    if 'dtacdb' in tacWorkbook.sheetnames:
        tacWorksheet = tacWorkbook['dtacdb']
    elif len(tacWorkbook.sheetnames)==1:
        tacWorksheet = tacWorkbook[tacWorkbook.sheetnames[0]]
    else:
        print('Please enter the antioxidant DB sheet name you want to use')
        print(tacWorkbook.sheetnames)
        dtacdbTag=input()
        tacWorksheet = tacWorkbook[dtacdbTag]
else:
    print('')
    print('There is no antioxidant DB file.')
    print("Please name the file dtacbd.xlsx and put it in this folder.")
    print("")
    print("If you don't have a antioxidant DB file, I'll make you a format in this folder")
    print("Please complete the file in accordance with the format and run it again.\n")
    asdf=pd.DataFrame.from_records([nameline])
    asdf.to_excel(
        '.\dtacdb.xlsx',
        index=False,
        header=False,
        sheet_name = 'dtacdb'
        )
    ending(15)

print('Please enter the KNHANES file name or drag the KNHANES file here.')
tag1=input()
if os.path.isfile(tag1+'.xlsx'):
    peopleWorkbook = load_workbook(filename=tag1+".xlsx", data_only=True)
    if tag1 in peopleWorkbook.sheetnames:
        peopleWorksheet = peopleWorkbook[tag1]
    elif len(peopleWorkbook.sheetnames)==1:
        peopleWorksheet = peopleWorkbook[peopleWorkbook.sheetnames[0]]
    else:
        print('Please enter the sheet name you want to use')
        print(peopleWorkbook.sheetnames)
        tag2=input()
        peopleWorksheet = peopleWorkbook[tag2]
    outputFilePath = '.\output_'+tag1+'.xlsx'
    outputdetailFilePath = '.\outputdetail_'+tag1+'.xlsx'
    print("I'm working on the calculations. Please wait a minute.")
elif os.path.isfile(tag1):
    peopleWorkbook = load_workbook(tag1, data_only=True)
    if len(peopleWorkbook.sheetnames)==1:
        peopleWorksheet = peopleWorkbook[peopleWorkbook.sheetnames[0]]
    else:
        print('Please enter the sheet name you want to use')
        print(peopleWorkbook.sheetnames)
        tag2=input()
        peopleWorksheet = peopleWorkbook[tag2]
    outputFilePath= '.\output_'+currentTime+'.xlsx'
    outputdetailFilePath= '.\outputdetail_'+currentTime+'.xlsx'
    print("I'm working on the calculations. Please wait a minute.")
else:
    print("That file is not in this folder.")
    print("Put it in this folder.")
    ending(10)

# 항산화능 계산 해주는 함수
def taccalc(line, foodAntioxidantCapacity, sort):
    carotenoids = decimal.Decimal(0)
    vita = decimal.Decimal(0)
    vitc = decimal.Decimal(0)
    vite = decimal.Decimal(0)
    antioxidantVitanims = decimal.Decimal(0)
    flavonols = decimal.Decimal(0)
    flavones = decimal.Decimal(0)
    flavonones = decimal.Decimal(0)
    flavan_3_ols = decimal.Decimal(0)
    anthocyanins = decimal.Decimal(0)
    isoflavones = decimal.Decimal(0)
    flavonoids = decimal.Decimal(0)
    proanthocyanidines = decimal.Decimal(0)
    totalsum = decimal.Decimal(0)
    for i,ac in enumerate(foodAntioxidantCapacity,0):
        if 0<=i and i<=5:
            carotenoids = (carotenoids
                           + decimal.Decimal(line[vLo[sort]])
                           *decimal.Decimal(ac))
        elif i==6:
            if line[vLo['NF_RETIN']]=='':
                vita = decimal.Decimal('0')
            else:
                vita = (decimal.Decimal(line[vLo['NF_RETIN']])
                        * decimal.Decimal(nutrientAntioxidantCapacity[6]))
        elif i==7:
            if line[vLo['NF_VITC']]=='':
                vitc = decimal.Decimal('0')
            else:
                vitc = (decimal.Decimal(line[vLo['NF_VITC']])
                        * decimal.Decimal(nutrientAntioxidantCapacity[7]))
        elif 7<i and i<=9:
            vite = (vite
                    + decimal.Decimal(line[vLo[sort]])
                    *decimal.Decimal(ac))
        elif 9<i and i<=13:
            flavonols = (flavonols
                         + decimal.Decimal(line[vLo[sort]])
                         *decimal.Decimal(ac))
        elif 13<i and i<=15:
            flavones = (flavones
                        + decimal.Decimal(line[vLo[sort]])
                        *decimal.Decimal(ac))
        elif 15<i and i<=18:
            flavonones = (flavonones
                          + decimal.Decimal(line[vLo[sort]])
                          *decimal.Decimal(ac))
        elif 18<i and i<=28:
            flavan_3_ols = (flavan_3_ols
                            + decimal.Decimal(line[vLo[sort]])
                            *decimal.Decimal(ac))
        elif 28<i and i<=34:
            anthocyanins = (anthocyanins
                            + decimal.Decimal(line[vLo[sort]])
                            *decimal.Decimal(ac))
        elif 34<i and i<=39:
            isoflavones = (isoflavones
                           + decimal.Decimal(line[vLo[sort]])
                           *decimal.Decimal(ac))
        elif 39<i and i<=41:
            proanthocyanidines = (proanthocyanidines
                                  + decimal.Decimal(line[vLo[sort]])
                                  *decimal.Decimal(ac))
    antioxidantVitamins = carotenoids + vita + vitc + vite
    flavonoids = (flavonols + flavones + flavonones + flavan_3_ols
                  + anthocyanins + isoflavones)
    totalsum = antioxidantVitamins + flavonoids + proanthocyanidines
    return (line[0 : vLo['NF_INTK3']+1]
            + [
                totalsum, carotenoids, vita, vitc, vite, antioxidantVitamins,
                flavonols, flavones, flavonones, flavan_3_ols, anthocyanins,
                isoflavones, flavonoids, proanthocyanidines
                ]
            )


#-------------파일 처리 시작-------------
print("Antioxidant DB file reading.... start")
for c,tacRow in enumerate(tacWorksheet.rows,0):
    fta=[]
    for fa in tacRow:
        fta.append(fa.value)

# 항산화DB 파일 형식 확인 및 항산화DB 파일 입력
    if c==0:
        if fta[0:45]!=nameline:
            print("Antioxidant DB file format is wrong.")
            if not(os.path.isdir("Fill_it_out_according_to_this_format")):
                os.makedirs(os.path.join("Fill_it_out_according_to_this_format"))
                print("I'll make you a format in \"Fill_it_out_according_to_this_format\" folder")
                print("Please complete the file in accordance with the format and run it again.\n")
            os.chdir(targetFilePath+'\Fill_it_out_according_to_this_format')
            asdf=pd.DataFrame.from_records([nameline])
            asdf.to_excel(
                '.\dtacdb.xlsx',
                index=False,
                header=False,
                sheet_name = 'dtacdb'
                )
            ending(15)
        else:
            print("Antioxidant DB file format is correct.")
    else:
        fta[0]=fta[0].replace(' ', '').replace('　', '')
        if fta[2]=='e':
            tac[fta[0]]='e'
        else:
            ftac=[]
            for i,cell in enumerate(fta[3:45],0):
                if cell=='' or cell==None :
                    ftac.append(decimal.Decimal(0))
                else:
                    ftac.append(
                        decimal.Decimal(cell)
                        *decimal.Decimal(nutrientAntioxidantCapacity[i])
                        )
            ftac.append(int(fta[2]))
            tac[fta[0]]=ftac
tacWorkbook.close()
print("Antioxidant DB file reading.... complete")

#-------------계산 시작------------
print("KNHANES file reading.... start")
for peopleRow in peopleWorksheet:
    iden=[]
    for pa in peopleRow:
        iden.append(
            str(pa.value).
            replace(' ', '').
            replace('　', '').
            replace('None', '')
            )
    people.append(iden)
peopleWorkbook.close()
print("KNHANES file reading.... complete")

# 변수 위치기록
print("dietary TAC calculating.... start")
for c,iden in enumerate(people,0):
    if c==0:
        header=iden[:]
        for i,vnm in enumerate(header,0):
            vLo[vnm]=i
            
# 대상자 파일 입력 및 계산
    else:
        if (iden[vLo['ID']]!='' and iden[vLo['N_FNAME']]==''):
            supplement+=1
        elif iden[vLo['N_FNAME']] in tac:
            if tac[iden[vLo['N_FNAME']]]=='e':
                templine = (iden[0 : vLo['NF_INTK3']+1]
                          + ['Excluded food',0,0,0,0,0,0,0,0,0,0,0,0,0])
            elif tac[iden[vLo['N_FNAME']]][42]==0:
                templine = taccalc(iden, tac[iden[vLo['N_FNAME']]], 'NF_INTK')
            elif tac[iden[vLo['N_FNAME']]][42]==1:
                templine = taccalc(iden, tac[iden[vLo['N_FNAME']]], 'NF_INTK3')
            else:
                print('Sorting ERRER!!')
                ending(5)
            dtacd.append(templine)
            dtac.append(templine[0 : vLo['ID']+1]
                        + templine[vLo['NF_INTK3']+1 : vLo['NF_INTK3']+15])
        else:
            dtacd.append(iden[0 : vLo['NF_INTK3']+1] + ['Missing data'])
            dtac.append(iden[0 : vLo['ID']+1] + ['Missing data'])
print("dietary TAC calculating.... complete")

# ID별로 합치기
print("Adding by ID")
for c in range(len(dtac)):
    if c>0:
        if dtac[c-1][vLo['ID']]==dtac[c][vLo['ID']]:
            if dtac[c][vLo['ID']+1]=='Missing data':
                subsum[sc][vLo['ID']+1]="There's missing data here"
                missingData+=1
                subsum[sc].insert(vLo['ID']+2,missingData)
            elif missingData==0 and dtac[c][vLo['ID']+1]!='Excluded food':
                for i in range(1,15):
                    subsum[sc][vLo['ID']+i] = (subsum[sc][vLo['ID']+i]
                                               + dtac[c][vLo['ID']+i])
        else:
            sc+=1
            subsum.append(dtac[c])
            missingData = 0
            if dtac[c][vLo['ID']+1]=='Missing data':
                subsum[sc][vLo['ID']+1] = "There's missing data here"
                missingData+=1
                subsum[sc].insert(vLo['ID']+2,missingData)
            elif dtac[c][vLo['ID']+1]=='Excluded food':
                subsum[sc][vLo['ID']+1] = 0
    elif c==0:
        subsum.append(dtac[0])
print("Calculating complete")

# 변수명 출력            
print("Output to excel")
dtacd.insert(
    0,
    (header[0:vLo['NF_INTK3']+1]
     + ['TAC', 'Carotenoids', 'Vitamin A', 'Vitamin C', 'Vitamin E',
        'Antioxidant Vitamins', 'Flavonols', 'Flavones', 'Flavonones',
        'Flavan-3-ols', 'Anthocyanins', 'Isoflvones', 'Flavonoids',
        'Proanthocyanidines'])
    )
subsum.insert(
    0,
    (header[0:vLo['ID']+1]
     + ['DTAC', 'Carotenoids', 'Vitamin A', 'Vitamin C', 'Vitamin E',
        'Antioxidant Vitamins', 'Flavonols', 'Flavones', 'Flavonones',
        'Flavan-3-ols', 'Anthocyanins', 'Isoflvones', 'Flavonoids',
        'Proanthocyanidines'])
    )

# 파일 출력
asdf = pd.DataFrame.from_records(subsum)
asdf.to_excel(
    outputFilePath,
    index=False,
    header=False,
    sheet_name = 'output'
    )

asdf = pd.DataFrame.from_records(dtacd)
asdf.to_excel(
    outputdetailFilePath,
    index=False,
    header=False,
    sheet_name = 'outputdetail'
    )

print("All processing complete.\n")
print('Supplement intake',supplement)
print('( つ’-’)つ  made by D.H.Kim')
